<?php

/*

   表示関係関数

*/

// ヘッダ
function show_header( $onloadfunc )
{
    print(
        '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">'.
        '<html lang="ja">'.
        '<head>'.
        '<meta http-equiv="content-type" content="text/html; charset=utf-8">'.
        '<title>recfriio server</title>'.
        '<link rel="stylesheet" href="recfriio.css" type="text/css">'.
        '</head>'.
        '<body '.$onloadfunc.'>'
        );
}


// メニュー
function show_menu()
{
    $diskinfo = '';
    if( file_exists( SPOOL_DIRECTORY ) ) $diskinfo = '空き容量 '.(int)( disk_free_space( SPOOL_DIRECTORY )/1024/1024/1024 ).' G';
    else $diskinfo = '<font class="err">ファイルの保存先がありません</font>';


    print(
        '<a href="./recfriio.php">最新の状態に更新</a> '.
        ' <a href="help/help.html" target="_blank" >ヘルプ表示</a> '.
        ' '.$diskinfo
        );
}


// エラー表示
function show_err( &$errmsg )
{
    if( $errmsg ) print( '<table border=2 class="err" ><tr><td>'.$errmsg.'</td></tr></table><br />' );
}


// フッタ
function show_footer()
{
    print(
        '</body>'.
        '</html>'
        );
}


////////////////////////////////////////////////////


// 設定表示
function show_setting( $settingno, &$setting )
{
    if( ! is_array( $setting ) | count( $setting ) != SET_SIZE ) return FALSE;

    global $CHANNEL_TABLE;

    print(

        '<tr align=center>'.

        '<td>'.
        '<input type="text" size=12 name="comment'.$settingno.'" value="'.$setting[ SET_COMMENT ].'">'.
        '</td>'.

        '<td>'.
        '<select name="channel'.$settingno.'">'
        );

    foreach( $CHANNEL_TABLE as $ch => $chname ){

        print(
            '<option'
            );
        if( $ch == $setting[ SET_CHANNEL ] ) print( ' selected' );
        print(
            '>'.$chname.'('.$ch.')'.
            '</option>'
            );
    }

    print(
        '</select>'.
        '</td>'.

        '<td>'.
        '<input type="text" size=4 maxlength=5 name="duration'.$settingno.'" value="'.( $setting[ SET_DURATION ] / 60 ).'"> 分'.
        '</td>'.

        '<td>'.
        '<input type="text" size=10 name="namebase'.$settingno.'" value="'.$setting[ SET_NAMEBASE ].'">'.
        '</td>'.

        '<td>'.
        '<input type="checkbox" name="overwrite'.$settingno.'" value="1"'.( $setting[ SET_OVERWRITE ] ? '' : 'checked' ).'>しない'.
        '</td>'.

        '<td>'.
        '<input type="checkbox" name="udp'.$settingno.'" value="1"'.($setting[ SET_UDP ] ? 'checked' : '' ).'>送信'.
        '</td>'.

        '<td>'.
        '<input type="text" size=10 name="ip'.$settingno.'" value="'.$setting[ SET_IP ].'">'.
        '</td>'.

        '<td>'.
        '<input type="text" size=5 maxlength=5 name="port'.$settingno.'" value="'.$setting[ SET_PORT ].'">'.
        '</td>'.

        '<td>'.
        '<input type="submit" name="play'.$settingno.'" value="＞">'.
        '</td>'.

        '<td>'.
        '<input type="submit" name="rec'.$settingno.'" value="●">'.
        '</td>'.

        '</tr>'.
        "\n"
        );

    return TRUE;
}


// メイン画面の設定テーブル表示
function show_settingtable( &$setting_array, $from, $to )
{
    show_debug( 'show_settingtable '.$from.' to '.$to );

    print(
        '<table border=2>'.
        '<tr>'.
        '<th>コメント</th>'.
        '<th>チャンネル</th>'.
        '<th>録画時間</th>'.
        '<th>ファイル名</th>'.
        '<th>上書き</th>'.
        '<th>UDP</th>'.
        '<th>IP</th>'.
        '<th>ポート</th>'.
        '<th>視聴</th>'.   
        '<th>録画</th>'.
        '</tr>'
        );

    for( $settingno = $from; $settingno <= $to; ++$settingno ){
        show_setting( $settingno, $setting_array[ $settingno ] );
    }

    print( 
        '</table>' 
        );
}


///////////////////////////////////////////////////////


// 録画予約表示
function show_reserv( $settingno, &$setting )
{
    $time = time();
    $week_array = array( '日', '月', '火', '水', '木', '金', '土' );
    $err = FALSE;
    $broken = FALSE;
    if( ! is_array( $setting ) | count( $setting ) != SET_SIZE ) $broken = TRUE;

    global $CHANNEL_TABLE;

    $date = $setting[ SET_HOUR ].' 時 '.sprintf( '%02d', $setting[ SET_MIN ] ).' 分';

    if( ( $setting[ SET_HOUR ] < 0 || $setting[ SET_HOUR ] > 23 )
        || ( $setting[ SET_MIN ] < 0  || $setting[ SET_MIN ] > 59 )
        || ( $setting[ SET_HOUR ] == '' || $setting[ SET_MIN ] == '' ) ){
            $date = '<font class="err">'.$date.'</font>';
            $err = TRUE;
    }

    $duration = $setting[ SET_DURATION ] /60;
    if( $duration <= 0 ){
        $duration = '<font class="err">'.$duration.' 分</font>';
        $err = TRUE;
    }
    else $duration = $duration.' 分';

    $namebase = '';
    if( $setting[ SET_NAMEBASE ] ) $namebase =  $setting[ SET_NAMEBASE ];
    else{ 
        $namebase = '<font class="err">×</font>';
        $err = TRUE;
    }

    if( $setting[ SET_MODE ] == MODE_WEEK ){

        $week = '';
        for( $i = 0; $i < 7; ++$i ) if( $setting[ SET_SUN + $i ] ) $week = $week.$week_array[ $i ];
        if( ! $week ){
            $week = '<font class="err">×</font>';
            $err = TRUE;
        }
        $type = '週間('.$week.')';
    }
    else if( $setting[ SET_MODE ] == MODE_ONCE ) $type = '1回のみ';
    else $type ='<font class="err">×</font>';

    // スリープ時間
    if( $setting[ SET_SLEEPSEC ] <= 0 || $setting[ SET_SLEEPSEC ] >= 60  ) $err = TRUE;

    // UDP送信
    if( $setting[ SET_UDP ] ){

        if( ! $setting[ SET_IP ] || ! $setting[ SET_PORT ] ) $err = TRUE;
    }

    // 録画予定日
    if( $setting[ SET_MODE ] == MODE_ONCE && ! check_date( $setting ) ) $err = true;
    $recording = FALSE;
    if( is_recording( $setting, $time ) ){
        $strdate = "-";
        $recording = TRUE;
    }
    else {
        $nexttime = get_nexttime( $setting, $time );
        $strdate = date( 'y/n/d', $nexttime ).'('.$week_array[ (int)date( 'w', $nexttime ) ].')';
    }

    print(
        '<tr align=center>'
    );

   if( $broken ) print( '<td><font class="err">壊れています</font></td>' );
   else if( $err ) print( '<td><font class="err">エラー</font></td>' );
   else if( ! $setting[ SET_ACTIVE ] ) print( '<td>無効</td>' );
   else if( $recording ) print( '<td>録画中</td>' );
   else print( '<td>-</td>' );

   print(
        '<td>'.
        ( $setting[ SET_COMMENT ] ? $setting[ SET_COMMENT ] : '-' ).
        '</td>'
    );

    print(
        '<td>'
        );

    foreach( $CHANNEL_TABLE as $ch => $chname ){
        if( $ch == $setting[ SET_CHANNEL ] ) print( $chname.'('.$ch.')' );
    }

    print(

        '</td>'.

        '<td>'.$type.'</td>'.

        '<td>'.
        ( ( $err || $broken ) ? '<font class="err">？</font>' : $strdate ).
        '</td>'.

        '<td>'.
        $date.
        '</td>'.

        '<td>'.
        $duration.
        '</td>'.

        '<td>'.
        $namebase.
        '</td>'.

        '<td>'.
        '<input type="submit" name="edit'.$settingno.'" value="編集">'.
        '</td>'.

        '<td>'.
        '<input type="hidden" name="id'.$settingno.'" value="'.$setting[ SET_ID ].'">'.
        '<input type="submit" name="del'.$settingno.'" value="削除">'.
        '</td>'.

        '</tr>'
        );

    return TRUE;
}


// メイン画面の予約一覧テーブル表示
function show_reservtable( &$setting_array, $from, $to )
{
    show_debug( 'show_reservtable '.$from.' to '.$to );

    print(
        '<table border=2>'.
        '<tr>'.
        '<th>状態</th>'.
        '<th>コメント</th>'.
        '<th>チャンネル</th>'.
        '<th>タイプ</th>'.
        '<th>予定日</th>'.
        '<th>開始時刻</th>'.
        '<th>録画時間</th>'.
        '<th>ファイル名</th>'.
        '<th>編集</th>'.
        '<th>削除</th>'.
        '</tr>'
        );

    for( $settingno = $from; $settingno <= $to; ++$settingno ){
        show_reserv( $settingno, $setting_array[ $settingno ] );
    }

    print( 
        '</table>' 
        );
}


// 予約設定編集画面表示
function show_reservedit( $settingno, &$setting, $disabled )
{
    global $CHANNEL_TABLE;


    print(
        '<input type="checkbox" name="active'.$settingno.'" '.( ! $setting[ SET_ACTIVE ] ? 'checked ' : '' ).( $disabled ? "disabled" : "" ).' >この予約を一時的に無効にする'.
        '<br>'.
        '<br>'
    );

    print(

        'コメント <input type="text" size=20 name="comment'.$settingno.'" value="'.$setting[ SET_COMMENT ].'" '.( $disabled ? "disabled" : "" ).'>'.
        '<br>'.
        '<br>'.

        'チャンネル <select name="channel'.$settingno.'" '.( $disabled ? "disabled" : "" ).'>'
        );

    foreach( $CHANNEL_TABLE as $ch => $chname ){

        print(
            '<option'
            );
        if( $ch == $setting[ SET_CHANNEL ] ) print( ' selected' );
        print(
            '>'.$chname.'('.$ch.')'.
            '</option>'
            );
    }

    print(
        '</select>'.
        '<br>'.
        '<br>'.

        '予約タイプ'.
        ' <input type="radio" id="once" onClick="toggle_items()"  name="type'.$settingno.'" value="once" '.
                ($setting[ SET_MODE ] == MODE_ONCE ? 'checked' : '' ).( $disabled ? "disabled" : "" ).'>一回のみ'.
        ' <input type="radio" onClick="toggle_items()" name="type'.$settingno.'" value="week" '.
                ($setting[ SET_MODE ] == MODE_WEEK ? 'checked' : '' ).( $disabled ? "disabled" : "" ).'>週間'.
        '<br>'.
        '<br>'.
        '日付 <input type="text" size=4 id="month" name="month'.$settingno.'" value="'.$setting[ SET_MONTH ].'" '.( $disabled ? "disabled" : "" ).'> 月'.
        ' <input type="text" size=4 id="day" name="day'.$settingno.'" value="'.$setting[ SET_DAY ].'" '.( $disabled ? "disabled" : "" ).'> 日'.
        '<br>'.
        '<br>'.

        '曜日'.
        ' <input type="checkbox" id="sun" name="sun'.$settingno.'" '.($setting[ SET_SUN ] ? 'checked ' : '' ).( $disabled ? "disabled" : "" ).' >日'.
        ' <input type="checkbox" id="mon" name="mon'.$settingno.'" '.($setting[ SET_MON ] ? 'checked ' : '' ).( $disabled ? "disabled" : "" ).' >月'.
        ' <input type="checkbox" id="tue" name="tue'.$settingno.'" '.($setting[ SET_TUE ] ? 'checked ' : '' ).( $disabled ? "disabled" : "" ).' >火'.
        ' <input type="checkbox" id="wed" name="wed'.$settingno.'" '.($setting[ SET_WED ] ? 'checked ' : '' ).( $disabled ? "disabled" : "" ).' >水'.
        ' <input type="checkbox" id="thu" name="thu'.$settingno.'" '.($setting[ SET_THU ] ? 'checked ' : '' ).( $disabled ? "disabled" : "" ).' >木'.
        ' <input type="checkbox" id="fri" name="fri'.$settingno.'" '.($setting[ SET_FRI ] ? 'checked ' : '' ).( $disabled ? "disabled" : "" ).' >金'.
        ' <input type="checkbox" id="sat" name="sat'.$settingno.'" '.($setting[ SET_SAT ] ? 'checked ' : '' ).( $disabled ? "disabled" : "" ).' >土'.
        '<br>'.
        '<br>'.

        '時刻 <input type="text" size=4 name="hour'.$settingno.'" value="'.$setting[ SET_HOUR ].'" '.( $disabled ? "disabled" : "" ).'> 時(0-23)'.
        ' <input type="text" size=4 name="min'.$settingno.'" value="'.$setting[ SET_MIN ].'" '.( $disabled ? "disabled" : "" ).'> 分(0-59)'.
        '<br>'.
        '<br>'.

        '録画時間 <input type="text" size=5 maxlength=5 name="duration'.$settingno.'" value="'.( $setting[ SET_DURATION ] / 60 ).'" '.( $disabled ? "disabled" : "" ).'> 分'.
        '<br>'.
        '<br>'.

        '録画マージン時間 <input type="text" size=5 maxlength=5 name="sleepsec'.$settingno.'" value="'.( 60 - $setting[ SET_SLEEPSEC ] ).'" '
           .( $disabled ? "disabled" : "" ).'> 秒(1-59)'.
        '<br>'.
        '<br>'.

        'ファイル名(拡張子不要) <input type="text" size=20 name="namebase'.$settingno.'" value="'.$setting[ SET_NAMEBASE ].'" '.( $disabled ? "disabled" : "" ).'>'.
        '<br>'.
        '<br>'.

        '上書き <input type="checkbox" name="overwrite'.$settingno.'" value="1"'
        .( $setting[ SET_OVERWRITE ] ? '' : 'checked' ).' '.( $disabled ? "disabled" : "" ).'>しない(日付を付ける)'.
        '<br>'.
        '<br>'.

        'UDP <input type="checkbox" name="udp'.$settingno.'" value="1"'.($setting[ SET_UDP ] ? 'checked ' : '' ).( $disabled ? "disabled" : "" ).'>送信する'.
        ' IP <input type="text" size=10 name="ip'.$settingno.'" value="'.$setting[ SET_IP ].'" '.( $disabled ? "disabled" : "" ).'>'.
        ' ポート <input type="text" size=5 maxlength=5 name="port'.$settingno.'" value="'.$setting[ SET_PORT ].'" '.( $disabled ? "disabled" : "" ).'>'.
        '<br />'.
        '<br />'
    );
}


///////////////////////////////////////////////////////////////////



// ステータス行表示
function show_status( $statusno, &$status )
{
    if( ! is_array( $status ) ) return FALSE;
    if( count( $status ) != STATUSSIZE ) return FALSE;

    $pid = $status[ PID ];

    global $CHANNEL_TABLE;
    $channel = $CHANNEL_TABLE[ $status[ CHANNEL ] ].'('.$status[ CHANNEL ].')';

    $starttime = date( 'm/d H:i:s', $status[ STARTTIME ] );
    $duration = $status[ DURATION ];
    $sec = time() - $status[ STARTTIME ];

    $sec = (int)($sec/60).':'.sprintf( '%02d', $sec%60 );
    $duration = (int)($duration/60).':'.sprintf( '%02d', $duration%60 );

    $namebase = $status[ NAMEBASE ];

    $udp = '-';
    $ip = '-';
    $port = '-';
    if( $status[ UDP ] ){
         $udp = '送信中';
         $ip = $status[ IP ];
         $port = $status[ PORT ];
    }

    print(
        '<tr align=center>'.
        '<td>'.$pid.'</td>'.
        '<td>'.$channel.'</td>'.
        '<td>'.$starttime.'</td>'.
        '<td>'.$sec.'/'.$duration.'</td>'.
        '<td>'.$namebase.'</td>'.
        '<td>'.$udp.'</td>'.
        '<td>'.$ip.'</td>'.
        '<td>'.$port.'</td>'.

        '<td>'.
        '<input type="hidden" name="pid'.$statusno.'" value="'.$pid.'">'.
        '<input type="submit" name="stop'.$statusno.'" value="■">'.
        '</td>'.

        '</tr>'
        );

    return TRUE;
}


// メイン画面のステータス一覧テーブル表示
function show_statustable( &$status_array, $from, $to )
{
    print(
        '<table border=2>'.
        '<tr>'.
        '<th>PID</th>'.
        '<th>チャンネル</th>'.
        '<th>開始時刻</th>'.
        '<th>経過時間</th>'.
        '<th>出力先</th>'.
        '<th>UDP</th>'.
        '<th>IP</th>'.
        '<th>ポート</th>'.
        '<th>停止</th>'.
        '</tr>'
        );

    for( $statusno = $from; $statusno <= $to; ++$statusno ){
        show_status( $statusno, $status_array[ $statusno ] );
    }

    print( 
        '</table>'
    );
}


?>
