<?php

  /*

    本体

  */

require_once( 'include.php' );

$errmsg = '';
$errmsg_reserv = '';


// クッキーを見てパネルを開閉する
$show_main = 'on';
$show_reserv = 'off';
$show_status = 'on';
if( isset( $_COOKIE[ 'main' ] ) ) $show_main = $_COOKIE[ 'main' ];
if( isset( $_COOKIE[ 'reservview' ] ) ) $show_reserv = $_COOKIE[ 'reservview' ];
if( isset( $_COOKIE[ 'statusview' ] ) ) $show_status = $_COOKIE[ 'statusview' ];

show_debug( 'main = '.$show_main );
show_debug( 'reserv = '.$show_reserv );
show_debug( 'status = '.$show_status );


$opnumber = -1;
$operate = get_operate( $opnumber, MAXSETTING );

$id = 0;
if( isset( $_POST[ 'id'.$opnumber ] ) ) $id = $_POST[ 'id'.$opnumber ];

$pid = 0;
if( isset( $_POST[ 'pid'.$opnumber ] ) ) $pid = $_POST[ 'pid'.$opnumber ];


// 録画設定の読み込みと更新
try{

    $settingfile = get_settingfile();
    $setting_array = array();
    if( file_exists( $settingfile  ) ) read_csv( $settingfile, $setting_array );

    // 設定ファイル更新
    if( count( $setting_array ) < MAXSETTING || $operate == OP_REC || $operate == OP_PLAY || $operate == OP_SAVE ){

        update_setting( $setting_array, $operate, MAXSETTING );

        // 録画スクリプト実行
        if( $operate == OP_REC || $operate == OP_PLAY ) exec_recfriio( $operate, $setting_array[ $opnumber ] );
    }

    // 停止
    if( $operate == OP_STOP ){

        stop_recfriio( $pid );
    }
}
catch( Exception $e ){ $errmsg = $e->getMessage(); }


// 予約設定更新とcrontabへの登録
try{

    if( $operate == OP_UPDATE || $operate === OP_DEL ){

        $reservfile = get_reservfile();
        $reserv_array = array();
        if( file_exists( $reservfile ) ) read_csv( $reservfile, $reserv_array );

        // 予約ファイル更新
        if( $operate == OP_UPDATE ) update_reserv( $reserv_array, $opnumber, $id );

        // 削除
        if( $operate == OP_DEL ) remove_reserv( $reserv_array, $id );

        // crontab 登録
        regist_crontab( $reserv_array );
    }

}
catch( Exception $e ){ $errmsg_reserv = $e->getMessage(); }

// 予約エラーの場合は crontab をクリアする
if( $errmsg_reserv ){

    try{
        $reserv_array_tmp = array();
        regist_crontab( $reserv_array_tmp );
    }
    catch( Exception $e ){ $errmsg_reserv = $e->getMessage(); }
}



///////////////////////////////////////////////



// 表示

show_header( 'onLoad="update_view()"' );

print(

    '<script language="JavaScript">'.
    "<!--\n".

    // 予約とステータス画面の表示
    'var http_reserv = false;'.
    'var http_status = false;'.

    'function update_reserv()'.
    '{'.
    '   if( ! http_reserv ) return;'.
    '   if( http_reserv.readyState == 4 && http_reserv.status == 200 ){'.
    '        document.getElementById( "reservview" ).innerHTML = http_reserv.responseText;'.
    '    }'.
    '}'.

    'function update_status()'.
    '{'.
    '   if( ! http_status ) return;'.
    '   if( http_status.readyState == 4 && http_status.status == 200 ){'.
    '        document.getElementById( "statusview" ).innerHTML = http_status.responseText;'.
    '        setTimeout( "update_view()", 1000*'.REFRESH.');'.
    '    }'.
    '}'.

    'function update_view()'.
    '{'.
    '    if( window.XMLHttpRequest ){'.
    '        http_reserv = new XMLHttpRequest();'.
    '        http_status = new XMLHttpRequest();'.
    '    }'.

    '    if( ! http_status ){'.

    '        try{'.
    '            http_reserv = new ActiveXObject( "Msxml2.XMLHTTP" );'.
    '            http_status = new ActiveXObject( "Msxml2.XMLHTTP" );'.
    '        } catch( e ){}'.
    '    }'.

    '    if( ! http_status ){'.

    '        try{'.
    '            http_reserv = new ActiveXObject( "Microsoft.XMLHTTP" );'.
    '            http_status = new ActiveXObject( "Microsoft.XMLHTTP" );'.
    '        } catch( e ){}'.
    '    }'.

    '    if( http_status ){'.

    '        http_reserv.open( "GET", "./reserv.php", true );'.
    '        http_reserv.onreadystatechange = update_reserv;'.
    '        http_reserv.setRequestHeader("If-Modified-Since", "Thu, 01 Jun 1970 00:00:00 GMT" );'.
    '        http_reserv.send("");'.

    '        http_status.open( "GET", "./status.php", true );'.
    '        http_status.onreadystatechange = update_status;'.
    '        http_status.setRequestHeader("If-Modified-Since", "Thu, 01 Jun 1970 00:00:00 GMT" );'.
    '        http_status.send("");'.
    '    }'.

    '}'.

    // バークリックでパネル開閉
    'function show_div( ID )'.
    '{'.
    '    if( document.getElementById( ID ).style.display == "block" ){'.
    '        document.getElementById( ID ).style.display = "none";'.
    '        document.getElementById( "toggle"+ID ).innerHTML = "▼";'.
    '        document.cookie = ID+"=off;";'.
    '    }'.
    '    else{'.
    '        document.getElementById( ID ).style.display = "block";'.
    '        document.getElementById( "toggle"+ID ).innerHTML = "▲";'.
    '        document.cookie = ID+"=on;";'.
    '    }'.
    '}'.

    'function show_main(){ show_div( "main" ); }'.
    'function show_reserv(){ show_div( "reservview" ); }'.
    'function show_status(){ show_div( "statusview" ); }'.

    '//-->'.
    '</script>'
);


show_menu();


// 操作画面
print(

    '<div class="title" onclick="show_main()" ><div class="name">操作</div><div class="toggle" id="togglemain" >'.
    ( $show_main == 'on' ? "▲" : "▼" ).'</div></div>'.
    '<div id="main" style="display:'.( $show_main == 'on' ? "block" : "none" ).'" >'.

    '<form action="./recfriio.php" method="post">'
    );

show_settingtable( $setting_array, 0, MAXSETTING-1 );

print( 
    '<input type="submit" name="save" value="全て保存">'.
    '</form>'.
    '<br />'
    );

print( '</div>' );
show_err( $errmsg );


// 録画予約画面
print(
    '<div class="title" onclick="show_reserv()" ><div class="name">録画予約</div><div class="toggle" id="togglereservview" >'.
    ( $show_reserv == 'on' ? "▲" : "▼" ).'</div></div>'.
    '<div id="reservview" style="display:'.( $show_reserv == 'on' ? "block" : "none" ).'" ></div>'
    );
show_err( $errmsg_reserv );



// ステータス画面
print(
    '<div class="title" onclick="show_status()" ><div class="name">動作状況</div><div class="toggle" id="togglestatusview" >'.
    ( $show_status == 'on' ? "▲" : "▼" ).'</div></div>'.
    '<div id="statusview" style="display:'.( $show_status == 'on' ? "block" : "none" ).'" ></div>'
    );

show_footer();

?>
