<?php

/*

    録画予約の削除確認、編集、追加画面

*/

require_once( 'include.php' );
$errmsg = '';

// 操作取得
$opnumber = -1;
$operate = get_operate( $opnumber, MAXRESERV );

try{

    $id = 0;
    if( isset( $_POST[ 'id'.$opnumber ] ) ) $id = $_POST[ 'id'.$opnumber ];
    show_debug( 'id = '.$id );

    $setting = get_setting_by_id( $id, get_vardir().RESERVFILE );
    if( $id && ! $setting ){
        throw new Exception( 'エラー(reserv) : 既に削除されています。' );
    }

    $settingno = 0; // ダミー番号

    // 新規追加
    $new = FALSE;
    if( $operate == OP_EDIT && ! $setting ){
        $setting = get_default_setting();

        $time = time();
        $setting[ SET_MONTH ] = (int)date( 'm', $time );
        $setting[ SET_DAY ] = (int)date( 'd', $time );
        $setting[ SET_HOUR ] = (int)date( 'H', $time );
        $setting[ SET_MIN ] = (int)date( 'i', $time );
        $setting[ SET_SUN + ( (int)date( 'w', $time )%7 ) ] = TRUE;
        $setting[ SET_SLEEPSEC ] = 60 - MARGINSEC;
        $new = TRUE;
    }

    /////////////////////////////////

    // 表示

    // 削除確認
    if( $operate == OP_DEL ){

        show_header( '' );

        print(
            '<div class="title">予約情報削除確認</div>'.
            '<form action="recfriio.php" method="post">'
        );

        show_reservedit( $settingno, $setting, TRUE );

        print(
            '<input type="hidden" name="id'.$settingno.'" value="'.$setting[ SET_ID ].'">'.
            '以上の設定を削除しますか？ <input type="submit" name="del'.$settingno.'" value="削除">'.
            ' <input type="submit" name="cancel" value="キャンセル">'.
            '</form>' 
            );
    }

    // 編集、追加
    else if( $operate == OP_EDIT ){

        show_header( 'onLoad="toggle_items()"' );

        print(
            '<script language="JavaScript">'.
            "<!--\n".
            'function toggle_items(){'.
            '    val = document.getElementById( "once" ).checked;'.
            '    document.getElementById( "month" ).disabled = ! val;'.
            '    document.getElementById( "day" ).disabled = ! val;'.
            '    document.getElementById( "sun" ).disabled = val;'.
            '    document.getElementById( "mon" ).disabled = val;'.
            '    document.getElementById( "tue" ).disabled = val;'.
            '    document.getElementById( "wed" ).disabled = val;'.
            '    document.getElementById( "thu" ).disabled = val;'.
            '    document.getElementById( "fri" ).disabled = val;'.
            '    document.getElementById( "sat" ).disabled = val;'.
            '}'.
            '//-->'.
            '</script>'
        );

        print(
            '<div class="title">予約情報'.( $new ? '追加' : '編集' ).'</div>'.
            '<form action="recfriio.php" method="post">'
        );

        show_reservedit( $settingno, $setting, FALSE );

        print(
            '<input type="hidden" name="id'.$settingno.'" value="'.$setting[ SET_ID ].'">'.
            '<input type="submit" name="update'.$settingno.'" value="'.( $new ? '追加' : '更新' ).'">'.
            ' <input type="submit" name="cancel" value="キャンセル">'.
            '</form>'
        );
    }
}
catch( Exception $e ){ $errmsg = $e->getMessage(); }

// エラー表示
show_err( $errmsg );
if( $errmsg ){
    print(
        '<form action="recfriio.php" method="post">'.
        ' <input type="submit" name="cancel" value="戻る">'.
        '</form>'
        );
}

show_footer();

?>

